'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _currencySymbolMap = require('currency-symbol-map');

var _currencySymbolMap2 = _interopRequireDefault(_currencySymbolMap);

var _Range = require('./Range');

var _Range2 = _interopRequireDefault(_Range);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defaults = {
  productName: '',
  // in miles
  distance: 0,
  range: new _Range2.default(),
  // in seconds
  duration: 0,
  currencyCode: '',
  // wont show up unless > 1
  surgeMultiplier: 1
};

var PriceEstimate = function (_Record) {
  _inherits(PriceEstimate, _Record);

  function PriceEstimate() {
    _classCallCheck(this, PriceEstimate);

    return _possibleConstructorReturn(this, (PriceEstimate.__proto__ || Object.getPrototypeOf(PriceEstimate)).apply(this, arguments));
  }

  _createClass(PriceEstimate, [{
    key: 'getFormattedRange',
    value: function getFormattedRange() {
      return '' + (0, _currencySymbolMap2.default)(this.currencyCode) + this.range.low + '-' + (0, _currencySymbolMap2.default)(this.currencyCode) + this.range.high;
    }
  }, {
    key: 'getFormattedDistance',
    value: function getFormattedDistance() {
      return this.distance + ' mi.';
    }
  }]);

  return PriceEstimate;
}((0, _immutable.Record)(defaults));

exports.default = PriceEstimate;