'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _UberService = require('./UberService');

var _UberService2 = _interopRequireDefault(_UberService);

var _PriceEstimatesTableBuilder = require('./tables/builders/PriceEstimatesTableBuilder');

var _PriceEstimatesTableBuilder2 = _interopRequireDefault(_PriceEstimatesTableBuilder);

var _TimeEstimatesTableBuilder = require('./tables/builders/TimeEstimatesTableBuilder');

var _TimeEstimatesTableBuilder2 = _interopRequireDefault(_TimeEstimatesTableBuilder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CommandExecutionService = function () {
  function CommandExecutionService() {
    _classCallCheck(this, CommandExecutionService);

    this.uberService = new _UberService2.default();
  }

  _createClass(CommandExecutionService, [{
    key: 'executePriceEstimates',
    value: function executePriceEstimates(start, end) {
      if (typeof start !== 'string') {
        throw new TypeError('start address should be a string');
      }

      if (typeof end !== 'string') {
        throw new TypeError('end address should be a string');
      }

      return this.uberService.getPriceEstimates(start, end).then(function (estimates) {
        return _PriceEstimatesTableBuilder2.default.build(estimates);
      });
    }
  }, {
    key: 'executeTimeEstimates',
    value: function executeTimeEstimates(address) {
      if (typeof address !== 'string') {
        throw new TypeError('address should be a string');
      }

      return this.uberService.getTimeEstimates(address).then(function (estimates) {
        return _TimeEstimatesTableBuilder2.default.build(estimates);
      });
    }
  }]);

  return CommandExecutionService;
}();

exports.default = CommandExecutionService;