'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _uberClient = require('uber-client');

var _GeocodeService = require('./GeocodeService');

var _GeocodeService2 = _interopRequireDefault(_GeocodeService);

var _PriceEstimates = require('../data/PriceEstimates');

var _PriceEstimates2 = _interopRequireDefault(_PriceEstimates);

var _PriceEstimatesTranslator = require('./translators/PriceEstimatesTranslator');

var _PriceEstimatesTranslator2 = _interopRequireDefault(_PriceEstimatesTranslator);

var _TimeEstimates = require('../data/TimeEstimates');

var _TimeEstimates2 = _interopRequireDefault(_TimeEstimates);

var _TimeEstimatesTranslator = require('./translators/TimeEstimatesTranslator');

var _TimeEstimatesTranslator2 = _interopRequireDefault(_TimeEstimatesTranslator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var UberService = function () {
  function UberService() {
    _classCallCheck(this, UberService);

    this.client = new _uberClient.UberClient('We0MNCaIpx00F_TUopt4jgL9BzW3bWWt16aYM4mh');
    this.geocodeService = new _GeocodeService2.default();
  }

  _createClass(UberService, [{
    key: 'getTimeEstimates',
    value: function getTimeEstimates(address) {
      var _this = this;

      return this.geocodeService.getLocations(address).then(function (locations) {
        return UberService.getFirstLocation(locations);
      }).then(function (location) {
        return _this.client.getTimeEstimates({ start: location.coordinate }).then(function (estimates) {
          return new _TimeEstimates2.default({
            location: location,
            estimates: _TimeEstimatesTranslator2.default.translate(estimates)
          });
        });
      });
    }
  }, {
    key: 'getPriceEstimates',
    value: function getPriceEstimates(start, end) {
      var _this2 = this;

      var startLocation = this.geocodeService.getLocations(start).then(function (locations) {
        return UberService.getFirstLocation(locations);
      });
      var endLocation = this.geocodeService.getLocations(end).then(function (locations) {
        return UberService.getFirstLocation(locations);
      });
      return Promise.all([startLocation, endLocation]).then(function (values) {
        return _this2.client.getPriceEstimates({ start: values[0].coordinate,
          end: values[1].coordinate }).then(function (response) {
          return new _PriceEstimates2.default({ start: values[0],
            end: values[1],
            estimates: _PriceEstimatesTranslator2.default.translate(response) });
        });
      });
    }
  }], [{
    key: 'getFirstLocation',
    value: function getFirstLocation(locations) {
      if (locations.isEmpty()) {
        throw new RangeError('no locations for address');
      }

      return locations.first();
    }
  }]);

  return UberService;
}();

exports.default = UberService;