'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nodeEmoji = require('node-emoji');

var _nodeEmoji2 = _interopRequireDefault(_nodeEmoji);

var _immutable = require('immutable');

var _cliTable = require('cli-table2');

var _cliTable2 = _interopRequireDefault(_cliTable);

var _Utilities = require('../../../Utilities');

var _Utilities2 = _interopRequireDefault(_Utilities);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var PriceEstimatesTableBuilder = function () {
  function PriceEstimatesTableBuilder() {
    _classCallCheck(this, PriceEstimatesTableBuilder);
  }

  _createClass(PriceEstimatesTableBuilder, null, [{
    key: 'build',
    value: function build(estimates) {
      var table = PriceEstimatesTableBuilder.buildInitialTable();
      estimates.estimates.forEach(function (estimate) {
        if (estimate.productName !== 'TAXI') {
          table.push(PriceEstimatesTableBuilder.buildEstimateRow(estimate));
        }
      });
      table.push(PriceEstimatesTableBuilder.buildLocationRow(estimates.start.name, false));
      table.push(PriceEstimatesTableBuilder.buildLocationRow(estimates.end.name, true));
      return table.toString();
    }
  }, {
    key: 'getTableHeaders',
    value: function getTableHeaders() {
      return _immutable.List.of(_nodeEmoji2.default.get('oncoming_automobile'), _nodeEmoji2.default.get('money_with_wings'), _nodeEmoji2.default.get('arrows_clockwise'), _nodeEmoji2.default.get('hourglass_flowing_sand'), _nodeEmoji2.default.get('boom') + ' Surge' + _nodeEmoji2.default.get('boom'));
    }
  }, {
    key: 'buildInitialTable',
    value: function buildInitialTable() {
      var table = new _cliTable2.default();
      var formattedHeaders = (0, _immutable.List)(PriceEstimatesTableBuilder.getTableHeaders().map(function (header) {
        return (0, _immutable.Map)({ content: header, hAlign: 'center' });
      }));
      table.push(formattedHeaders.toJS());
      return table;
    }
  }, {
    key: 'buildEstimateRow',
    value: function buildEstimateRow(estimate) {
      return [estimate.productName, estimate.getFormattedRange(), estimate.getFormattedDistance(), _Utilities2.default.generateFormattedTime(estimate.duration), PriceEstimatesTableBuilder.buildSurgeMultiplierSymbol(estimate.surgeMultiplier)];
    }
  }, {
    key: 'buildSurgeMultiplierSymbol',
    value: function buildSurgeMultiplierSymbol(surgeMultiplier) {
      return surgeMultiplier === 1 ? _nodeEmoji2.default.get('no_entry_sign') : surgeMultiplier + 'x ' + _nodeEmoji2.default.get('grimacing');
    }
  }, {
    key: 'buildLocationRow',
    value: function buildLocationRow(name, isEnd) {
      var symbol = isEnd ? _nodeEmoji2.default.get('end') : _nodeEmoji2.default.get('round_pushpin');
      return [{
        colSpan: 1,
        content: symbol,
        hAlign: 'center'
      }, {
        colSpan: 4,
        content: name
      }];
    }
  }]);

  return PriceEstimatesTableBuilder;
}();

exports.default = PriceEstimatesTableBuilder;