'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nodeEmoji = require('node-emoji');

var _nodeEmoji2 = _interopRequireDefault(_nodeEmoji);

var _immutable = require('immutable');

var _cliTable = require('cli-table2');

var _cliTable2 = _interopRequireDefault(_cliTable);

var _Utilities = require('../../../Utilities');

var _Utilities2 = _interopRequireDefault(_Utilities);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TimeEstimatesTableBuilder = function () {
  function TimeEstimatesTableBuilder() {
    _classCallCheck(this, TimeEstimatesTableBuilder);
  }

  _createClass(TimeEstimatesTableBuilder, null, [{
    key: 'build',
    value: function build(estimates) {
      var table = TimeEstimatesTableBuilder.buildInitialTable(estimates.location.name);
      TimeEstimatesTableBuilder.groupByTimeEstimate(estimates.estimates).entrySeq().forEach(function (e) {
        return table.push([_Utilities2.default.generateFormattedTime(e[0]), e[1].join(',')]);
      });
      return table.toString();
    }
  }, {
    key: 'getTableHeaders',
    value: function getTableHeaders() {
      return _immutable.List.of(_nodeEmoji2.default.get('hourglass_flowing_sand'), _nodeEmoji2.default.get('oncoming_automobile'));
    }
  }, {
    key: 'buildInitialTable',
    value: function buildInitialTable(locationName) {
      var table = new _cliTable2.default();
      table.push([{
        colSpan: 2,
        content: _nodeEmoji2.default.get('round_pushpin') + ' ' + locationName,
        hAlign: 'center'
      }]);
      var formattedHeaders = (0, _immutable.List)(TimeEstimatesTableBuilder.getTableHeaders().map(function (header) {
        return (0, _immutable.Map)({ content: header, hAlign: 'center' });
      }));
      table.push(formattedHeaders.toJS());
      return table;
    }
  }, {
    key: 'groupByTimeEstimate',
    value: function groupByTimeEstimate(estimates) {
      var timeEstimateGroups = (0, _immutable.Map)();
      estimates.forEach(function (estimate) {
        if (timeEstimateGroups.has(estimate.estimateSeconds)) {
          var productNames = timeEstimateGroups.get(estimate.estimateSeconds);
          productNames = productNames.push(estimate.productName);
          timeEstimateGroups = timeEstimateGroups.set(estimate.estimateSeconds, productNames);
        } else {
          timeEstimateGroups = timeEstimateGroups.set(estimate.estimateSeconds, _immutable.List.of(estimate.productName));
        }
      });
      return timeEstimateGroups;
    }
  }]);

  return TimeEstimatesTableBuilder;
}();

exports.default = TimeEstimatesTableBuilder;