'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _Coordinate = require('../../data/Coordinate');

var _Coordinate2 = _interopRequireDefault(_Coordinate);

var _Location = require('../../data/Location');

var _Location2 = _interopRequireDefault(_Location);

var _Utilities = require('../../Utilities');

var _Utilities2 = _interopRequireDefault(_Utilities);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var GeocodeTranslator = function () {
  function GeocodeTranslator() {
    _classCallCheck(this, GeocodeTranslator);
  }

  _createClass(GeocodeTranslator, null, [{
    key: 'translate',
    value: function translate(json) {
      if (!('status' in json)) {
        throw new ReferenceError('expected status field');
      }

      if (json['status'] !== 'OK') {
        throw new TypeError('unexpected status value');
      }

      if (!('results' in json)) {
        throw new ReferenceError('expected results field');
      }

      var results = json['results'];
      if (!Array.isArray(results)) {
        throw new TypeError('expected array of results');
      }

      return (0, _immutable.List)(results.map(function (result) {
        return GeocodeTranslator.translateLocation(result);
      }));
    }
  }, {
    key: 'translateLocation',
    value: function translateLocation(json) {
      if (!('formatted_address' in json)) {
        throw new ReferenceError('expected formatted address field');
      }

      var formattedAddress = json['formatted_address'];

      if (!('geometry' in json)) {
        throw new ReferenceError('expected geometry field');
      }

      var geometry = json['geometry'];

      if (!('location' in geometry)) {
        throw new ReferenceError('expected location field in geometry field');
      }

      var location = geometry['location'];

      if (!('lat' in location)) {
        throw new ReferenceError('expected lat field in location field');
      }

      if (!('lng' in location)) {
        throw new ReferenceError('expected lng field in location field');
      }

      var latitude = location['lat'];
      var longitude = location['lng'];

      if (typeof formattedAddress !== 'string') {
        throw new TypeError('expected address to be a string');
      }

      if (!_Utilities2.default.isFloat(latitude)) {
        throw new TypeError('expected latitude to be a float');
      }

      if (!_Utilities2.default.isFloat(longitude)) {
        throw new TypeError('expected longitude to be a float');
      }

      return new _Location2.default({
        name: formattedAddress,
        coordinate: new _Coordinate2.default({
          latitude: latitude,
          longitude: longitude
        })
      });
    }
  }]);

  return GeocodeTranslator;
}();

exports.default = GeocodeTranslator;