'use strict';
'use es6';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _immutable = require('immutable');

var _TimeEstimate = require('../../data/TimeEstimate');

var _TimeEstimate2 = _interopRequireDefault(_TimeEstimate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TimeEstimatesTranslator = function () {
  function TimeEstimatesTranslator() {
    _classCallCheck(this, TimeEstimatesTranslator);
  }

  _createClass(TimeEstimatesTranslator, null, [{
    key: 'translate',
    value: function translate(response) {
      if (!('times' in response)) {
        throw new ReferenceError('expected times field');
      }

      var estimates = response['times'];
      if (!Array.isArray(estimates)) {
        throw new TypeError('expected times to be an array');
      }

      return (0, _immutable.List)(estimates.map(function (estimate) {
        return TimeEstimatesTranslator.translateEstimate(estimate);
      }));
    }
  }, {
    key: 'translateEstimate',
    value: function translateEstimate(estimate) {
      if (!('localized_display_name' in estimate)) {
        throw new ReferenceError('expected localized display name field');
      }

      if (!('estimate' in estimate)) {
        throw new ReferenceError('expected estimate field');
      }

      var displayName = estimate['localized_display_name'];
      if (typeof displayName !== 'string') {
        throw new TypeError('expected localized display name to be a string');
      }

      var estimateSeconds = estimate['estimate'];
      if (!Number.isInteger(estimateSeconds)) {
        throw new TypeError('expected seconds to be an integer');
      }

      return new _TimeEstimate2.default({
        productName: displayName,
        estimateSeconds: estimateSeconds
      });
    }
  }]);

  return TimeEstimatesTranslator;
}();

exports.default = TimeEstimatesTranslator;